function int_x_int(pos, size, pos2, size2)
	return not (pos + size < pos2 or pos2 + size2 < pos)
end

function distance(pos, size, pos2, size2)
	if int_x_int(pos, size, pos2, size2) then
		return 0
	end
	return math.min(
		math.abs(pos + size - pos2),
		math.abs(pos2 + size2 - pos))
end

-- simple AABB collision check
function rec_x_rec(pos, size, pos2, size2)
	return int_x_int(pos.x, size.x, pos2.x, size2.x) and
		int_x_int(pos.y, size.y, pos2.y, size2.y)
end

function max_distance(pos, size, pos2, size2)
	return math.max(
		distance(pos.x, size.x, pos2.x, size2.x),
		distance(pos.y, size.y, pos2.y, size2.y))
end

function objs_collide(obj1, obj2)
	return rec_x_rec(obj1.pos, obj1.size, obj2.pos, obj2.size)
end

function inside(pos, size, pos2, size2)
	if pos >= pos2 and pos + size <= pos2 + size2 then
		return true
	end
	return false
end

function rec_inside(pos, size, pos2, size2)
	if inside(pos.x, size.x, pos2.x, size2.x) then
		if inside(pos.y, size.y, pos2.y, size2.y) then
			return true
		end
	end
	return false
end

function obj_inside(obj1, obj2)
	return rec_inside(obj1.pos, obj1.size, obj2.pos, obj2.size)
end
