local sounds = {}
local game_music

local function get_sound(name)
	if sounds[name] == nil then
		local success, snd = pcall(love.sound.newSoundData, "sounds/" .. name)
		if success then
			sounds[name] = snd
		else
			sounds[name] = false
		end
	end
	
	if sounds[name] then
		local source = love.audio.newSource(sounds[name], "static")
		return source
	end
	
	return nil
end

local function get_music(name)
	local song = love.audio.newSource("music/" .. name, "stream")
	sond:setLooping(true)
	return song
end

do
	get_sound("laser.wav")
	get_sound("laser2.wav")
	get_sound("miina.wav")
	get_sound("putum.wav")
	get_sound("tsut.wav")
end

function play_sound(name)
	if not config.sounds.mute then
		local snd = get_sound(name)
		if snd then snd:play() end
	end
end

function toggle_music(music)
	if game_music then
		if not music then
			game_music:stop()
		elseif game_music:isPaused() or
			game_music:isStopped() then
			
			game_music:play()
		end
	end
end

function play_music(name)
	if not config.music.mute then
		game_music:stop()
		game_music = get_music(name)
		if game_music then
			game_music:play()
		end
	end
end

